#include "APCRoutinePatch.h"

extern "C"{
	#include <ntddkbd.h>
}

#include <memory>

#include "CAPCContext.h"

__declspec(naked) HANDLE NTAPI NtUserGetForegroundWindow(void){
	__asm{
		mov eax, 0x1194; //NtUserGetForegroundWindows number in SSDT Shadow
		int 2eh; //Call SYSENTER gate
		retn;
	}
}

void NTAPI Patch_APCRoutine(PVOID pAPCContext, PIO_STATUS_BLOCK pIoStatusBlock, ULONG ulReserved){
	std::auto_ptr<CAPCContext> pContext((CAPCContext*)pAPCContext);
	PKEYBOARD_INPUT_DATA pKeyData = (PKEYBOARD_INPUT_DATA)pContext->GetUserBuffer();
	KEY_STATE_DATA keyData;

	keyData.pusScanCode = &pKeyData->MakeCode;

		if (pKeyData->Flags == KEY_MAKE){
			keyData.bPressed = true;
		}
		else{
			if (pKeyData->Flags == KEY_BREAK){
				keyData.bPressed = false;
			}
			else{
				pContext->GetOriginalAPCRoutine()(pContext->GetOriginalAPCContext(), 
												  pIoStatusBlock, 
												  ulReserved);

				return;
			}
		}

		try{
			pContext->GetObserver()->OnProcessEvent(keyData);
			pKeyData->Flags = keyData.bPressed ? KEY_MAKE : KEY_BREAK;
		}
		catch(std::exception& ex){
			DbgPrint("[KBHookLib]%s\n", ex.what());
		}

	pContext->GetOriginalAPCRoutine()(pContext->GetOriginalAPCContext(), 
									  pIoStatusBlock, 
									  ulReserved);

	return;
}

void APCRoutinePatch(IIRPProcessor *pIRPProcessor, PIRP pIRP){
	CAPCContext *pContext = 
		new CAPCContext(pIRP->Overlay.AsynchronousParameters.UserApcContext,
						pIRP->Overlay.AsynchronousParameters.UserApcRoutine,
						pIRP->UserBuffer,
						pIRPProcessor->GetDeviceObserver(),
						pIRP);

	pIRP->Overlay.AsynchronousParameters.UserApcRoutine = Patch_APCRoutine;
	pIRP->Overlay.AsynchronousParameters.UserApcContext = pContext;

	return;
}