#ifndef __C_FILTER_MANAGER_H__
#define __C_FILTER_MANAGER_H__

#include <map>

#include "IFiltersManager.h"

class CFilterManager :
    public IFiltersManager
{
	typedef std::map<PDEVICE_OBJECT, IFilterObject*> FiltersMap;
	typedef std::pair<PDEVICE_OBJECT, IFilterObject*> FilterPair;

    public:

		void RegisterFilter(PDEVICE_OBJECT pAttachedFilter, 
							PDEVICE_OBJECT pNextDevice,
							IKBExternalObserver *pExternalObserver);
        void UnregisterFilter(PDEVICE_OBJECT pAttachedFilter);
        IFilterObject* GetFilter(PDEVICE_OBJECT pDeviceObject);
        bool IsExists(PDEVICE_OBJECT pDeviceObject);

        NTSTATUS DispatchPNP(PDEVICE_OBJECT pFilterObject, PIRP pIRP);

		~CFilterManager(void);

    private:
        FiltersMap m_filters;
};

#endif