#ifndef __C_KBDCLASS_HOOK_H__
#define __C_KBDCLASS_HOOK_H__

extern "C"{
	#include <ntifs.h>

	NTSYSAPI NTSTATUS NTAPI ObReferenceObjectByName(PUNICODE_STRING ObjectName,
													ULONG Attributes,
													PACCESS_STATE AccessState,
													ACCESS_MASK DesiredAccess,
													POBJECT_TYPE ObjectType,
													KPROCESSOR_MODE AccessMode,
													PVOID ParseContext OPTIONAL,
													PVOID* Object);
	extern POBJECT_TYPE* IoDriverObjectType;
}

#include "IExternalObserver.h"

#include <string>

class CKbdclassHook{
	public:
		CKbdclassHook(const std::wstring& wsDriverName, 
					  PDRIVER_DISPATCH pHookCallback,
					  IKBExternalObserverEx *pObserver);

		NTSTATUS Call_DispatchRead(PDEVICE_OBJECT pDeviceObject, PIRP pIRP);

		bool IsHooked(void) const;
		void Hook(void);
		void Unhook(void);

		~CKbdclassHook(void);
	private:
		PDRIVER_DISPATCH m_pOriginalDispatchRead;
		PDRIVER_DISPATCH m_pHookCallback;
		PDRIVER_OBJECT m_pClassDriver;
		std::wstring m_wsClassDrvName;
		bool m_bEnabled;
		IKBExternalObserverEx *m_pObserver;
};

#endif