#ifndef __I_FILTER_OBJECT_H__
#define __I_FILTER_OBJECT_H__

#include "IIRPProcessor.h"
#include "IIRPDispatcher.h"

struct IFilterObject:
	public IIRPProcessor,
	public IIRPDispatcher
{
	//Filter device settings
	virtual PDEVICE_OBJECT GetSelf(void) = 0;
	virtual PDEVICE_OBJECT GetNextDevice(void) = 0;
	virtual const ULONG GetPendingPacketsCount(void) const = 0;

	//Device stack controls
	virtual void AttachFilter(void) = 0;
	virtual void DetachFilter(void) = 0;
	virtual const bool IsAttached(void) = 0;

	virtual ~IFilterObject(void){}
};

#endif