#ifndef __I_FILTERS_MANAGER_H__
#define __I_FILTERS_MANAGER_H__

extern "C"{
	#include <ntifs.h>
}

#include "IFilterObject.h"

struct IFiltersManager{
	virtual void RegisterFilter(PDEVICE_OBJECT pAttachedFilter, 
								PDEVICE_OBJECT pNextDevice,
								IKBExternalObserver *pExternalObserver) = 0;
	virtual void UnregisterFilter(PDEVICE_OBJECT pAttachedFilter) = 0;
	virtual IFilterObject* GetFilter(PDEVICE_OBJECT pDeviceObject) = 0;
	virtual bool IsExists(PDEVICE_OBJECT pDeviceObject) = 0;

	//IRP dispatchers
	virtual NTSTATUS DispatchPNP(PDEVICE_OBJECT pFilterObject, PIRP pIRP) = 0;

	virtual ~IFiltersManager(void){}
};

#endif