#include "Guards.h"

#include <stdexcept>

//-------------------------------------------------------------------------------------------------
CAutoSpinLockGuard::CAutoSpinLockGuard(CSpinLockWrapper *pSpinLockGuard):
    m_pSpinLockGuard(pSpinLockGuard)
{
    m_pSpinLockGuard->Enter();
}

CAutoSpinLockGuard::~CAutoSpinLockGuard(void){
    m_pSpinLockGuard->Leave();
}
//-------------------------------------------------------------------------------------------------
CNativeHandleGuard::CNativeHandleGuard(const HANDLE hObject /* = NULL */):
    CBaseGuardImpl<HANDLE, NULL>(hObject)
{
}

CNativeHandleGuard::CNativeHandleGuard(CNativeHandleGuard& guard):
    CBaseGuardImpl<HANDLE, NULL>(guard)
{
}

void CNativeHandleGuard::Shutdown(void){

    if (!__super::IsInvalid()){
        ZwClose(__super::Release());
    }

    return;
}

CNativeHandleGuard::~CNativeHandleGuard(void){

    this->Shutdown();

}
//-------------------------------------------------------------------------------------------------
CSystemThreadGuard::CSystemThreadGuard(PKSTART_ROUTINE pStartRoutine, PVOID pContext, const bool bAsync):
    m_bAsync(bAsync)
{
    HANDLE hThread = NULL;
    NTSTATUS lStatus = PsCreateSystemThread(&hThread,
                                            THREAD_ALL_ACCESS,
                                            NULL, 
                                            NULL, 
                                            NULL,
                                            pStartRoutine,
                                            pContext);

        if (!NT_SUCCESS(lStatus)){
            throw(std::runtime_error("[CSystemThreadWrapper::CSystemThreadWrapper] Cannot create system thread."));
        }

    m_handle.Reset(hThread);
}

CSystemThreadGuard::~CSystemThreadGuard(void){

        if (!m_handle.IsInvalid() && !m_bAsync){
            if (KeGetCurrentThread() != m_handle.Get()){
                KeWaitForSingleObject(m_handle.Get(), Executive, KernelMode, FALSE, NULL);
            }
        }

}
//-------------------------------------------------------------------------------------------------
