#ifndef __UTILS_NATIVE_GUARDS_H_
#define __UTILS_NATIVE_GUARDS_H_

extern "C"{
    #include <ntifs.h>
}

#include "Wrappers.h"
#include "GuardsPort.h"

//-------------------------------------------------------------------------------------------------
class CAutoSpinLockGuard{
    public:
        explicit CAutoSpinLockGuard(CSpinLockWrapper *pSpinLockGuard);
        ~CAutoSpinLockGuard(void);
    private:
        CSpinLockWrapper *m_pSpinLockGuard;
};
//-------------------------------------------------------------------------------------------------
class CNativeHandleGuard:
    public CBaseGuardImpl<HANDLE, NULL>
{
    public:
        explicit CNativeHandleGuard(const HANDLE hObject = NULL);
        CNativeHandleGuard(CNativeHandleGuard& guard);

        ~CNativeHandleGuard(void);

    private:
        void Shutdown(void);

};
//-------------------------------------------------------------------------------------------------
class CSystemThreadGuard{
    public:
        CSystemThreadGuard(PKSTART_ROUTINE pStartRoutine, PVOID pContext, const bool bAsync = true);
        ~CSystemThreadGuard(void);
    private:
        CNativeHandleGuard m_handle;
        bool m_bAsync;

        CSystemThreadGuard(CSystemThreadGuard&);
        CSystemThreadGuard& operator =(CSystemThreadGuard&);
};
//-------------------------------------------------------------------------------------------------

#endif;