#include "Wrappers.h"

#include <stdexcept>

//-------------------------------------------------------------------------------------------------
CSpinLockWrapper::CSpinLockWrapper(void):
    m_irql(KeGetCurrentIrql())
{

    KeInitializeSpinLock(&m_spinLock);

}

CSpinLockWrapper::CSpinLockWrapper(KSPIN_LOCK& spinLock):
    m_spinLock(spinLock),
    m_irql(KeGetCurrentIrql())
{
}

void CSpinLockWrapper::Enter(void){

    KeAcquireSpinLock(&m_spinLock, &m_irql);

    return;
}

void CSpinLockWrapper::Leave(void){

    KeReleaseSpinLock(&m_spinLock, m_irql);

    return;
}
//-------------------------------------------------------------------------------------------------
CNativeEventWrapper::CNativeEventWrapper(const EVENT_TYPE eventType, 
                                         const BOOLEAN bInitState)
{
    KeInitializeEvent(&m_eventObject, eventType, bInitState);
}

CNativeEventWrapper::CNativeEventWrapper(KEVENT& eventObject):
    m_eventObject(eventObject)
{
}

void CNativeEventWrapper::Set(void){

    KeSetEvent(&m_eventObject, 0, FALSE);

    return;
}

void CNativeEventWrapper::Reset(void){

    KeClearEvent(&m_eventObject);

    return;
}

const bool CNativeEventWrapper::IsSet(void){
    return(KeReadStateEvent(&m_eventObject) != 0);
}

void CNativeEventWrapper::Wait(PLARGE_INTEGER liTimeout){
    NTSTATUS lStatus = KeWaitForSingleObject(&m_eventObject, Executive, KernelMode, FALSE, liTimeout);

        if (!NT_SUCCESS(lStatus)){
            throw(std::runtime_error("KeWaitForSingleObject failed."));
        }

    return;
}

KEVENT& CNativeEventWrapper::GetObject(void){
    return(m_eventObject);
}