#ifndef __GUARDS_PORT_H__
#define __GUARDS_PORT_H__

//-------------------------------------------------------------------------------------------------
template<class T, T TInvalidValue>
    class CBaseGuardImpl
{
    typedef T StoredType;

    public:
        explicit CBaseGuardImpl(const StoredType object = TInvalidValue):
            m_object(object)
        {
        }

        CBaseGuardImpl(CBaseGuardImpl<StoredType, TInvalidValue>& guard):
            m_object(guard.Release())
        {
        }

        const StoredType Get(void) const{
            return(m_object);
        }

        void Reset(StoredType object){

                if (!this->IsInvalid()){
                    this->Shutdown();
                }

            m_object = object;

            return;
        }

        StoredType Release(void){
            StoredType temp = m_object;

            m_object = TInvalidValue;

            return(temp);
        }

        bool IsInvalid(void){
            return(m_object == TInvalidValue);
        }

        virtual void Shutdown(void) = 0;

    private:
        StoredType m_object;
};

#endif
